# CAD File Generation with Django and ezdxf
=====================================================

## Prerequisites
---------------

* Python 3.12+
* Django 5.0.7
* ezdxf for generating DWG and DXF files
* matplotlib for data visualization
* contourpy for contour plotting

## Project Setup
--------------

### 1. Create a virtual environment

Open a terminal or command prompt and run:
```
python -m venv myenv
```

Activate the virtual environment:
```
myenv\Scripts\activate (on Windows) source myenv/bin/activate (on Linux/macOS)
```
### 2. Install dependencies

Install the required dependencies by running:

```
pip install -r requirements.txt
```

### 3. Start the Django server

Start the Django server by running:

```
python manage.py runserver
```

The server will be available at `http://localhost:8000`.

## Project Features
---------------

* **CAD file generation**: Generate DWG and DXF files using ezdxf
* **Django web integration**: Integrate CAD functionality with a Django web application
* **CAD manipulations**: Use ezdxf for CAD file manipulations

## Key Libraries
--------------

* **ezdxf**: For generating and manipulating CAD files
* **matplotlib**: For data visualization
* **contourpy**: For contour plotting

## Troubleshooting
---------------

### Windows Installation Issues

#### Visual Studio Build Tools

If you encounter issues with installing dependencies, ensure that you have Visual Studio Build Tools installed. You can download it from the [Visual Studio website](https://visualstudio.microsoft.com/downloads/).

#### Matplotlib Installation Errors

If you encounter issues with installing matplotlib, try installing the Microsoft Visual C++ Redistributable package from the [Microsoft website](https://support.microsoft.com/en-us/help/2977003/the-latest-supported-visual-c-downloads).

## License
-------

This project is licensed under the [MIT License](https://opensource.org/licenses/MIT).

## Contributing
------------

Contributions are welcome! If you'd like to contribute to this project, please fork the repository and submit a pull request.
