from django import forms


class CreateDrawingForm(forms.Form):

    # INPUT PARAMETERS

    cab_left_cheek =  forms.TextInput()
    cab_right_cheek =  forms.TextInput()
    plenum_depth =  forms.IntegerField(label='Plenum Depth', min_value=0, required=False)
    plenum_length =  forms.IntegerField(label='Plenum Length', min_value=0, required=False)
    tapper_from_top =  forms.TextInput()
    tapper_from_back =  forms.TextInput()
    heat_sensor = forms.Select(choices=[('yes', 'yes'), ('no', 'no')])
    top_of_hood = forms.Select(choices=[('0 CLEARANCE', '0 CLEARANCE'), ('STANDARD', 'STANDARD')])
    hood_front = forms.Select(choices=[('0 CLEARANCE', '0 CLEARANCE'), ('STANDARD', 'STANDARD')])
    hood_back = forms.Select(choices=[('0 CLEARANCE', '0 CLEARANCE'), ('STANDARD', 'STANDARD')])
    visibility = forms.TextInput()
    cab_location = forms.Select(choices=[('right', 'right'), ('left', 'left')])


    # HOOD INFORMATION
    
    hood_length = forms.IntegerField(label='Hood Length', min_value=0, required=False)
    hood_width = forms.IntegerField(label='Hood Width', min_value=0, required=False)
    hood_height = forms.IntegerField(label='Hood Height', min_value=0, required=False)
    hang_height = forms.TextInput()
    hang_plan = forms.TextInput()
    hang_elev = forms.TextInput()
    hang_sect = forms.TextInput()
    drain_location = forms.Select(choices=[('RIGHT', 'RIGHT'), ('LEFT', 'LEFT')])
    hood_rc_config = forms.Select(choices=[('0 CLEARANCE', '0 CLEARANCE'), ('STANDARD', 'STANDARD')])
    hood_lc_config = forms.Select(choices=[('0 CLEARANCE', '0 CLEARANCE'), ('STANDARD', 'STANDARD')])


    # EXH COLLAR LOCATION INFORMATION

    exh_collar_length = forms.IntegerField(label='Exc Collar Lenght', min_value=0, required=False)
    exh_collar_width = forms.IntegerField(label='Exc Collar Width', min_value=0, required=False)
    exh_collar_loc = forms.IntegerField(label='Exc Collar Location', min_value=0, required=False)
    

    # MUA COLLAR LOCATION INFORMATION

    mua_collar_length = forms.IntegerField(label='Mua Collar Length', min_value=0, required=False)
    mua_collar_width = forms.IntegerField(label='Mua Collar Width', min_value=0, required=False)
    mua_collar_loc = forms.IntegerField(label='Mua Collar Location', min_value=0, required=False)


    # CABINET INFORMATION

    cab_visibility = forms.Select(choices=[('DCV - HOODCAB', 'DCV - HOODCAB'), ('DCV - REMOTECAB', 'DCV - REMOTECAB'), ('STD - HOODCAB', 'STD - HOODCAB'), ('STD - REMOTECAB', 'STD - REMOTECAB')])
    cab_size = forms.IntegerField(label='Cabinet Size', min_value=0, required=False)
    cab_height = forms.IntegerField(label='Cabinet Height', min_value=0, required=False)
    cab_width = forms.IntegerField(label='Cabinet Width', min_value=0, required=False)
    remote_cab_type = forms.IntegerField(label='Remote Cabinet Type', min_value=0, required=False)
    control_type = forms.IntegerField(label='Control Type', min_value=0, required=False)
    tank_qty = forms.Select(
            choices=[
                ('ANSUL-1', 'ANSUL-1'), 
                ('ANSUL-2', 'ANSUL-2'),
                ('ANSUL-3', 'ANSUL-3'),
                ('ANSUL-4', 'ANSUL-4'),
                ('ANSUL-5', 'ANSUL-5'),
                ('BUCKEYE-1', 'BUCKEYE-1'),
                ('BUCKEYE-2', 'BUCKEYE-2'),
                ('BUCKEYE-3', 'BUCKEYE-3'),
                ('BUCKEYE-4', 'BUCKEYE-4'),
                ('BUCKEYE-5', 'BUCKEYE-5')
            ]
        )


    # HOOD SCHEDULE INFO

    hood_no =  forms.CharField(label='Hood No', max_length=100, required=False)
    hood_mfg =  forms.CharField(label='Hood MFG', max_length=100, required=False)
    hood_model =  forms.TextInput()
    hood_type =  forms.TextInput()
    hood_meterial =  forms.TextInput()
    hood_weight =  forms.TextInput()
    exh_collar_qty = forms.IntegerField(label='Hood Collar Quantity', min_value=0, required=False)
    exh_collar_sp =  forms.TextInput()
    exh_collar_area =  forms.TextInput()
    exh_collar_cfm =  forms.TextInput()
    grease_duct_vel =  forms.TextInput()
    filter_type =   forms.TextInput()
    filter_qty1 =   forms.TextInput()
    filter_size1 = forms.TextInput()
    filter_qty2 = forms.TextInput()
    filter_size2 = forms.TextInput()
    filter_area = forms.TextInput()
    filter_vel = forms.TextInput()
    lights_qty = forms.IntegerField(label='Lights Quantity', min_value=0, required=False)
    switch_hood = forms.TextInput()
    switch_light = forms.TextInput()


    # PLENUM SCHEDULE INFORMATION

    hood_no2 = forms.TextInput()
    mua_collars_qty = forms.IntegerField(label='Plenum Collars Quantity', min_value=0, required=False)
    mua_collars_sp = forms.TextInput()
    mua_collars_cfm = forms.TextInput()
    mua_area = forms.TextInput()
    mua_vel = forms.TextInput()
    plenum_weight = forms.TextInput()
    
    
    # FAN SCHEDULE INFORMATION

    hood_no3 = forms.TextInput()
    label = forms.TextInput()
    fan_model = forms.TextInput()
    fan_mfg = forms.TextInput()
    fan_cfm = forms.TextInput()
    fan_sp = forms.TextInput()
    fan_hp = forms.TextInput()
    fan_voltage = forms.TextInput()
    fan_phase = forms.TextInput()
    fan_rpm = forms.TextInput()
    fan_amps = forms.TextInput()
    fan_weight = forms.TextInput()
    