from ezdxf.tools.text import MTextEditor

# Plenum Schedule Table START
def draw_plenum_schedule_table(msp, x_offset=0, y_offset=0, number_of_hoods=2, table_data={}):
    
    plenum_table_head_row_points = [
        (x_offset, y_offset),
        (x_offset + 200, y_offset),
        (x_offset + 200, y_offset - 26),
        (x_offset, y_offset - 26),
        (x_offset, y_offset - 19),
        (x_offset + 200, y_offset - 19),
        (x_offset + 200, y_offset - 10),
        (x_offset, y_offset - 10),
        (x_offset, y_offset - 21),
    ]
    
    plenum_table_heading = str(MTextEditor("PLENUM SCHEDULE").font(name="Arial-Bold", bold=True))

    msp.add_mtext(
        plenum_table_heading, 
        dxfattribs={
            'insert': (x_offset + 70, y_offset - 3), 
            'layer': 'TABLE',
            'char_height': 5,     
        }
    )
    
    msp.add_lwpolyline(plenum_table_head_row_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_head_column_points = [
        (x_offset, y_offset - 10),
        # first column
        (x_offset + 75, y_offset - 10),
        (x_offset + 75, y_offset - 19),
        # second column
        (x_offset + 75 + 65, y_offset - 19),
        (x_offset + 75 + 65, y_offset - 10),
        # third column
        (x_offset + 75 + 65 + 25, y_offset - 10),
        (x_offset + 75 + 65 + 25, y_offset - 19),
        # fourth column
        (x_offset + 75 + 65 + 25 + 20, y_offset - 19),
        (x_offset + 75 + 65 + 25 + 20, y_offset - 10),
        # fifth column
        (x_offset + 75 + 65 + 25 + 20 + 15, y_offset - 10),
        (x_offset + 75 + 65 + 25 + 20 + 15, y_offset - 19),
        
        (x_offset, y_offset - 19),
    ]
    
    first_column_x = x_offset + (65 / 2)
    first_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "PLENUM",
        dxfattribs={
            'insert': (first_column_x, first_column_y),
            'layer': 'TABLE',
            'char_height': 3  
        }
    )
    
    second_column_x = x_offset + 55 + (65 / 2)
    second_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "SUPPLY COLLAR",
        dxfattribs={
            'insert': (second_column_x, second_column_y),
            'layer': 'TABLE',
            'char_height': 3  
        }
    )
    
    third_column_x = x_offset + 75 + 65 + (25 / 2)
    third_column_y = (y_offset - 14)
    
    msp.add_mtext(
        "AREA OF MUA \nPERF",
        dxfattribs={
            'insert': (third_column_x, third_column_y),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    fourth_column_x = x_offset + 75 + 65 + 25 + (20 / 2)
    fourth_column_y = (y_offset - 14)
    
    msp.add_mtext(
        "MUA PERF \nVELOCITY",
        dxfattribs={
            'insert': (fourth_column_x, fourth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75,
            'attachment_point': 5  
        }
    )
    
    fifth_column_x = x_offset + 72 + 65 + 25 + 20 + (15 / 2)
    fifth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "WGT",
        dxfattribs={
            'insert': (fifth_column_x, fifth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    msp.add_lwpolyline(plenum_table_head_column_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_secondary_head_column_points1 = [
        (x_offset, y_offset - 26),
        
        (x_offset + 10, y_offset - 26),
        (x_offset + 10, y_offset - 19),
        
        (x_offset + 10 + 20, y_offset - 19),
        (x_offset + 10 + 20, y_offset - 26),
        
        (x_offset + 10 + 20 + 10, y_offset - 26),
        (x_offset + 10 + 20 + 10, y_offset - 19),
        
        (x_offset + 10 + 20 + 10 + 15, y_offset - 19),
        (x_offset + 10 + 20 + 10 + 15, y_offset - 26),
        
        (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 19),
        
        (x_offset, y_offset - 19),
    ]
    
    msp.add_mtext(
        "#",
        dxfattribs={
            'insert': (x_offset + 5, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "HOOD #",
        dxfattribs={
            'insert': (x_offset + 20, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "QTY",
        dxfattribs={
            'insert': (x_offset + 35, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "DEPTH",
        dxfattribs={
            'insert': (x_offset + 48, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "LENGTH",
        dxfattribs={
            'insert': (x_offset + 65, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    for i in range(number_of_hoods):
        plenum_table_secondary_head_column_points1_data = [
            (x_offset, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 19 - (i + 1) * 7),
            
            (x_offset, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["HOOD_NO"],
            dxfattribs={
                'insert': (x_offset + 5, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["HOOD_NO"],
            dxfattribs={
                'insert': (x_offset + 20, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            "1",
            dxfattribs={
                'insert': (x_offset + 35, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            f"{table_data[i]["PLENUMDEPTH"]} inch",
            dxfattribs={
                'insert': (x_offset + 48, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            f"{table_data[i]["PLENUMLENGTHTOTAL"]} inch",
            dxfattribs={
                'insert': (x_offset + 65, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=True, dxfattribs={'layer': 'TABLE'})
    
        msp.add_lwpolyline(plenum_table_secondary_head_column_points1_data, close=True, dxfattribs={'layer': 'TABLE'})
        
    msp.add_lwpolyline(plenum_table_secondary_head_column_points1, close=True, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_secondary_head_column_points2 = [
        (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26),
        
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10, y_offset - 19),
        
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25, y_offset - 19),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25, y_offset - 26),
        
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15, y_offset - 19),
        
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 19),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 26),
    ]
    
    msp.add_mtext(
        "QTY",
        dxfattribs={
            'insert': (x_offset + 80, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "SIZE",
        dxfattribs={
            'insert': (x_offset + 97, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "S.P.",
        dxfattribs={
            'insert': (x_offset + 117, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "CFM",
        dxfattribs={
            'insert': (x_offset + 133, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    for i in range(number_of_hoods):
        plenum_table_secondary_head_column_points2_data = [
            (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 26 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["MUA_COLLAR_QTY"],
            dxfattribs={
                'insert': (x_offset + 80, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["MUA_COLLAR_SIZE"],
            dxfattribs={
                'insert': (x_offset + 97, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["COLLAR_SP"],
            dxfattribs={
                'insert': (x_offset + 117, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data[i]["COLLAR_CFM"],
            dxfattribs={
                'insert': (x_offset + 133, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 26 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=True, dxfattribs={'layer': 'TABLE'})
        
        msp.add_lwpolyline(plenum_table_secondary_head_column_points2_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_lwpolyline(plenum_table_secondary_head_column_points2, close=False, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_secondary_head_column_points3 = [
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        plenum_table_secondary_head_column_points3_data = [
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["MUA_AREA"],
            dxfattribs={
                'insert': (x_offset + 152, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        
        msp.add_lwpolyline(plenum_table_secondary_head_column_points3_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(SQFT)",
        dxfattribs={
            'insert': (x_offset + 152, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(plenum_table_secondary_head_column_points3, close=True, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_secondary_head_column_points4 = [
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        plenum_table_secondary_head_column_points4_data = [
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["MUA_VELOCITY"],
            dxfattribs={
                'insert': (x_offset + 175, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(plenum_table_secondary_head_column_points4_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(FPM)",
        dxfattribs={
            'insert': (x_offset + 175, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(plenum_table_secondary_head_column_points4, close=True, dxfattribs={'layer': 'TABLE'})
    
    plenum_table_secondary_head_column_points5 = [
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 26),
        (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        plenum_table_secondary_head_column_points5_data = [
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            table_data[i]["PLENUM_WGT"],
            dxfattribs={
                'insert': (x_offset + 193, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20 + 10 + 25 + 15 + 15 + 25 + 20 + 15, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(plenum_table_secondary_head_column_points5_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(LBS)",
        dxfattribs={
            'insert': (x_offset + 193, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(plenum_table_secondary_head_column_points5, close=True, dxfattribs={'layer': 'TABLE'})

# Plenum Schedule Table END
